Index: code/trunk/src/modules/weapons/projectiles/BillboardProjectile.cc
===================================================================
--- code/trunk/src/modules/weapons/projectiles/BillboardProjectile.cc	(revision 10624)
+++ code/trunk/src/modules/weapons/projectiles/BillboardProjectile.cc	(revision 10629)
@@ -88,4 +88,15 @@
     /**
     @brief
+        Get the material of the BillboardProjectile.
+    @return
+        The material name.
+    */
+    const std::string& BillboardProjectile::getMaterial()
+    {
+        return this->billboard_.getMaterial();
+    }
+
+    /**
+    @brief
         Is called when the visibility of the BillboardProjectile has changed.
     */
Index: code/trunk/src/modules/weapons/projectiles/BillboardProjectile.h
===================================================================
--- code/trunk/src/modules/weapons/projectiles/BillboardProjectile.h	(revision 10624)
+++ code/trunk/src/modules/weapons/projectiles/BillboardProjectile.h	(revision 10629)
@@ -60,4 +60,5 @@
             virtual void setColour(const ColourValue& colour);
             virtual void setMaterial(const std::string& material);
+            virtual const std::string& getMaterial();
             virtual void changedVisibility();
 
Index: code/trunk/src/modules/weapons/projectiles/CMakeLists.txt
===================================================================
--- code/trunk/src/modules/weapons/projectiles/CMakeLists.txt	(revision 10624)
+++ code/trunk/src/modules/weapons/projectiles/CMakeLists.txt	(revision 10629)
@@ -5,4 +5,6 @@
   Projectile.cc
   LightningGunProjectile.cc
+  SplitGunProjectile.cc
+  IceGunProjectile.cc
   Rocket.cc
   RocketOld.cc
Index: code/trunk/src/modules/weapons/projectiles/IceGunProjectile.cc
===================================================================
--- code/trunk/src/modules/weapons/projectiles/IceGunProjectile.cc	(revision 10629)
+++ code/trunk/src/modules/weapons/projectiles/IceGunProjectile.cc	(revision 10629)
@@ -0,0 +1,98 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabien Vultier
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+    @file IceGunProjectile.cc
+    @brief Implementation of the IceGunProjectile class.
+*/
+
+#include "IceGunProjectile.h"
+
+#include "core/CoreIncludes.h"
+#include "graphics/Model.h"
+
+namespace orxonox
+{
+    RegisterClass(IceGunProjectile);
+
+    IceGunProjectile::IceGunProjectile(Context* context) : Projectile(context)
+    {
+        RegisterObject(IceGunProjectile);
+
+        this->setCollisionShapeRadius(8.0f);
+
+        this->setFreezeTime(3.0);
+        this->setFreezeFactor(0.5);
+
+        Model* model = new Model(this->getContext());
+        model->setMeshSource("IceBolt.mesh");
+        model->setScale(15.0);
+        this->attach(model);
+        model->setPosition(Vector3(0,0,0));
+    }
+
+    /**
+    @brief
+        Sets the freeze time variable to the passed value.
+    */
+    void IceGunProjectile::setFreezeTime(float freezeTime)
+    {
+        freezeTime_ = freezeTime;
+    }
+
+    /**
+    @brief
+        Sets the freeze factor variable to the passed value.
+    */
+    void IceGunProjectile::setFreezeFactor(float freezeFactor)
+    {
+        freezeFactor_ = freezeFactor;
+    }
+
+    bool IceGunProjectile::collidesAgainst(WorldEntity* otherObject, const btCollisionShape* cs, btManifoldPoint& contactPoint)
+    {        
+        bool bCollision = Projectile::collidesAgainst(otherObject, cs, contactPoint);
+
+        if (bCollision)
+        {
+            // If there was a collision, attach a IceGunFreezer to the hit object.
+            IceGunFreezer* freezer = new IceGunFreezer(this->getContext());
+            freezer->setFreezeTime(freezeTime_);
+            freezer->setFreezeFactor(freezeFactor_);
+            otherObject->attach(freezer);            
+
+            Vector3 offset = this->getWorldPosition() - otherObject->getWorldPosition();
+            freezer->setPosition(Vector3(0,0,0));
+            freezer->translate(offset, WorldEntity::World);
+            // Start the freezing effect.
+            freezer->startFreezing();
+        }
+
+        return bCollision;
+    }
+}
Index: code/trunk/src/modules/weapons/projectiles/IceGunProjectile.h
===================================================================
--- code/trunk/src/modules/weapons/projectiles/IceGunProjectile.h	(revision 10629)
+++ code/trunk/src/modules/weapons/projectiles/IceGunProjectile.h	(revision 10629)
@@ -0,0 +1,71 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabien Vultier
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+    @file IceGunProjectile.h
+    @brief Definition of the IceGunProjectile class.
+*/
+
+#ifndef _IceGunProjectile_H__
+#define _IceGunProjectile_H__
+
+#include "weapons/WeaponsPrereqs.h"
+
+#include <string>
+#include "tools/Timer.h"
+#include "BillboardProjectile.h"
+#include "weapons/IceGunFreezer.h"
+
+namespace orxonox
+{
+
+    /**
+    @brief
+        The IceGunProjectile is a projectile that attaches a IceGunFreezer to the hit object. This object gets slowed down by the IceGunFreezer.
+    @author
+        Fabien Vultier
+    @ingroup WeaponsProjectiles
+    */
+    class _WeaponsExport IceGunProjectile : public Projectile
+    {
+        public:
+            IceGunProjectile(Context* context);
+            virtual ~IceGunProjectile() {}
+
+            virtual void setFreezeTime(float freezeTime);
+            virtual void setFreezeFactor(float freezeFactor);
+
+        protected:
+            virtual bool collidesAgainst(WorldEntity* otherObject, const btCollisionShape* cs, btManifoldPoint& contactPoint);
+        private:         
+            float freezeTime_; //The duration of the freezing effect on a target
+            float freezeFactor_; //The strength of the freezing effect
+    };
+}
+
+#endif /* _IceGunProjectile_H__ */
Index: code/trunk/src/modules/weapons/projectiles/Projectile.cc
===================================================================
--- code/trunk/src/modules/weapons/projectiles/Projectile.cc	(revision 10624)
+++ code/trunk/src/modules/weapons/projectiles/Projectile.cc	(revision 10629)
@@ -39,5 +39,4 @@
 #include "core/command/Executor.h"
 
-#include "objects/collisionshapes/SphereCollisionShape.h"
 #include "worldentities/pawns/Pawn.h"
 
@@ -60,7 +59,8 @@
             this->setCollisionType(Dynamic);
 
-            SphereCollisionShape* shape = new SphereCollisionShape(this->getContext());
-            shape->setRadius(20.0f);
-            this->attachCollisionShape(shape);
+            // Create a sphere collision shape and attach it to the projectile.
+            collisionShape_ = new SphereCollisionShape(this->getContext());
+            setCollisionShapeRadius(20.0f);
+            this->attachCollisionShape(collisionShape_);
 
             this->destroyTimer_.setTimer(this->lifetime_, false, createExecutor(createFunctor(&BasicProjectile::destroyObject, this)));
@@ -76,5 +76,4 @@
         SetConfigValue(lifetime_, 4.0f).description("The time in seconds a projectile stays alive");
     }
-
 
     void Projectile::tick(float dt)
@@ -93,3 +92,10 @@
     }
 
+    void Projectile::setCollisionShapeRadius(float radius)
+    {
+        if (collisionShape_ != NULL && radius > 0)
+        {
+            collisionShape_->setRadius(radius);
+        }        
+    }
 }
Index: code/trunk/src/modules/weapons/projectiles/Projectile.h
===================================================================
--- code/trunk/src/modules/weapons/projectiles/Projectile.h	(revision 10624)
+++ code/trunk/src/modules/weapons/projectiles/Projectile.h	(revision 10629)
@@ -39,4 +39,5 @@
 #include "tools/Timer.h"
 #include "worldentities/MovableEntity.h"
+#include "objects/collisionshapes/SphereCollisionShape.h"
 
 #include "BasicProjectile.h"
@@ -66,7 +67,11 @@
             virtual bool collidesAgainst(WorldEntity* otherObject, const btCollisionShape* cs, btManifoldPoint& contactPoint);
 
+        protected:
+            virtual void setCollisionShapeRadius(float radius);
+
         private:
             float lifetime_; //!< The time the projectile exists.
             Timer destroyTimer_; //!< Timer to destroy the projectile after its lifetime has run out.
+            WeakPtr<SphereCollisionShape> collisionShape_; // The collision shape of the projectile.            
     };
 }
Index: code/trunk/src/modules/weapons/projectiles/SplitGunProjectile.cc
===================================================================
--- code/trunk/src/modules/weapons/projectiles/SplitGunProjectile.cc	(revision 10629)
+++ code/trunk/src/modules/weapons/projectiles/SplitGunProjectile.cc	(revision 10629)
@@ -0,0 +1,161 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabien Vultier
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+    @file SplitGunProjectile.h
+    @brief Implementation of the SplitGunProjectile class.
+*/
+
+#include "SplitGunProjectile.h"
+
+#include "core/CoreIncludes.h"
+#include "core/command/Executor.h"
+#include "util/Convert.h"
+#include "util/Math.h"
+
+namespace orxonox
+{
+    RegisterClass(SplitGunProjectile);
+
+    SplitGunProjectile::SplitGunProjectile(Context* context) : BillboardProjectile(context)
+    {
+        RegisterObject(SplitGunProjectile);
+
+        this->numberOfSplits_ = 0;
+        this->numberOfChilds_ = 0;
+        this->splitTime_ = 1.0f;
+        this->spread_ = 0.2f;
+        this->damageReduction_ = 1.0f;
+    }
+
+    void SplitGunProjectile::setNumberOfSplits(int numberOfSplits)
+    {
+        if (numberOfSplits >= 0)
+        {
+            this->numberOfSplits_ = numberOfSplits;
+        }
+        else
+        {
+            this->numberOfSplits_ = 0;
+        }
+    }
+
+    void SplitGunProjectile::setNumberOfChilds(int numberOfChilds)
+    {
+        if (numberOfChilds >= 0)
+        {
+            this->numberOfChilds_ = numberOfChilds;
+        }
+        else
+        {
+            this->numberOfChilds_ = 0;
+        }
+    }
+
+    /**
+    @brief
+        This function starts a timer that will cause the projectile to split after a time defined by the argument @param splitTime.        
+    */
+    void SplitGunProjectile::setSplitTime(float splitTime)
+    {
+        if (splitTime >= 0)
+        {
+            this->splitTime_ = splitTime;
+            this->splitTimer_.setTimer(this->splitTime_, false, createExecutor(createFunctor(&SplitGunProjectile::split, this)));
+        }
+        else
+        {
+            this->splitTime_ = 0;
+        }
+    }
+
+    void SplitGunProjectile::setSpread(float spread)
+    {
+        this->spread_ = spread;
+    }
+
+    /**
+    @brief
+        This is the setter function for the damageReduction_ variable. The value of the variable is bounded between 0 and 1.
+    */
+    void SplitGunProjectile::setDamageReduction(float damageReduction)
+    {
+        this->damageReduction_ = (damageReduction >= 0.0f ? damageReduction : 1.0f);
+    }
+
+    /**
+    @brief
+        If this function is called the projectile splits up into many child projectiles. The original projectiles does not get destroyed but it will never split up again.
+    */
+    void SplitGunProjectile::split()
+    {
+        if (numberOfSplits_ > 0)
+        {
+            -- numberOfSplits_;
+
+            // Reduce damage of this projectile
+            this->setDamage(this->getDamage() * this->damageReduction_ / (this->numberOfChilds_+1));
+
+            // Calculate a normalized vector (velocityOffset) that is perpendicluar to the velocity of this projectile. Since there are infinitly many perpendicular vectors a random one is chosen.
+            Vector3 velocityInitial = this->getVelocity();
+            Vector3 velocityOffset = velocityInitial.perpendicular();
+            velocityOffset.normalise();
+            Degree angle = Degree(rnd(0,360));
+            velocityOffset = Quaternion(angle, velocityInitial.normalisedCopy()) * velocityOffset;
+            velocityOffset.normalise();
+
+            // Create as many childs as defined by numberOfChilds_
+            for (int i = 0; i < numberOfChilds_; ++i)
+            {
+                // Every child projectile should fly uniform in different directions -> Rotate the velocityOffset in every iteration
+                velocityOffset = Quaternion(Degree(360/numberOfChilds_), velocityInitial.normalisedCopy()) * velocityOffset;
+                velocityOffset.normalise();
+
+                SplitGunProjectile* projectile = new SplitGunProjectile(this->getContext());                
+
+                projectile->setMaterial(this->getMaterial());
+                projectile->setOrientation(this->getOrientation());
+                projectile->setPosition(this->getPosition());
+                projectile->setVelocity(velocityInitial + spread_*velocityOffset*velocityInitial.length());
+
+                projectile->setNumberOfSplits(this->numberOfSplits_);
+                projectile->setNumberOfChilds(this->numberOfChilds_);
+                projectile->setSplitTime(this->splitTime_);
+                projectile->setSpread(this->spread_);
+                projectile->setDamageReduction(this->damageReduction_);
+
+                projectile->setShooter(this->getShooter());
+                projectile->setDamage(this->getDamage());
+                projectile->setShieldDamage(this->getShieldDamage());
+                projectile->setHealthDamage(this->getHealthDamage());
+            }
+
+            numberOfSplits_ = 0;
+        }
+    }
+}
Index: code/trunk/src/modules/weapons/projectiles/SplitGunProjectile.h
===================================================================
--- code/trunk/src/modules/weapons/projectiles/SplitGunProjectile.h	(revision 10629)
+++ code/trunk/src/modules/weapons/projectiles/SplitGunProjectile.h	(revision 10629)
@@ -0,0 +1,77 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabien Vultier
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+    @file IceGunProjectile.h
+    @brief Definition of the SplitGunProjectile class.
+*/
+
+#ifndef _SplitGunProjectile_H__
+#define _SplitGunProjectile_H__
+
+#include "weapons/WeaponsPrereqs.h"
+
+#include <string>
+#include "tools/Timer.h"
+#include "BillboardProjectile.h"
+
+namespace orxonox
+{
+
+    /**
+    @brief
+        The SplitGunProjectile is a projectile that may split up into many child projectiles.
+    @author
+        Fabien Vultier
+    @ingroup WeaponsProjectiles
+    */
+    class _WeaponsExport SplitGunProjectile : public BillboardProjectile
+    {
+        public:
+            SplitGunProjectile(Context* context);
+            virtual ~SplitGunProjectile() {}
+
+            virtual void setNumberOfSplits(int numberOfSplits);
+            virtual void setNumberOfChilds(int numberOfChilds);
+            virtual void setSplitTime(float splitTime);
+            virtual void setSpread(float spread);
+            virtual void setDamageReduction(float damageReduction);
+
+        private:            
+            int numberOfSplits_;
+            int numberOfChilds_;
+            float splitTime_;
+            float spread_;
+            float damageReduction_; //The damage of a child projectile is reduced by this factor
+            Timer splitTimer_;
+
+            virtual void split();            
+    };
+}
+
+#endif /* _SplitGunProjectile_H__ */
